Public Attributes

# IUSBDevice Interface Reference

The IUSBDevice interface represents a virtual USB device attached to the virtual machine. More...

Inheritance diagram for IUSBDevice:

List of all members.

## Public Attributes
readonly attribute wstringUUID | id
| Unique USB device ID.
readonly attribute unsigned short | vendorId
| Vendor ID.
readonly attribute unsigned short | productId
| Product ID.
readonly attribute unsigned short | revision
| Product revision number.
readonly attribute wstring | manufacturer
| Manufacturer string.
readonly attribute wstring | product
| Product string.
readonly attribute wstring | serialNumber
| Serial number string.
readonly attribute wstring | address
| Host specific address of the device.
readonly attribute unsigned short | port
| Host USB port number the device is physically connected to.
readonly attribute unsigned short | version
| The major USB version of the device - 1 or 2.
readonly attribute unsigned short | portVersion
| The major USB version of the host USB port the device is physically connected to - 1 or 2.
readonly attribute boolean | remote
| Whether the device is physically connected to a remote VRDE client or to a local host machine.

## Detailed Description

The IUSBDevice interface represents a virtual USB device attached to the virtual machine.

A collection of objects implementing this interface is stored in the IConsole::USBDevices attribute which lists all USB devices attached to a running virtual machine's USB controller.

Interface ID:
  `{F8967B0B-4483-400F-92B5-8B675D98A85B}`

## Member Data Documentation

readonly attribute wstringUUID IUSBDevice::id

Unique USB device ID.

This ID is built from vendorId, productId, revision and serialNumber.

readonly attribute unsigned short IUSBDevice::vendorId

Vendor ID.

readonly attribute unsigned short IUSBDevice::productId

Product ID.

readonly attribute unsigned short IUSBDevice::revision

Product revision number.

This is a packed BCD represented as unsigned short. The high byte is the integer part and the low byte is the decimal.

readonly attribute wstring IUSBDevice::manufacturer

Manufacturer string.

readonly attribute wstring IUSBDevice::product

Product string.

readonly attribute wstring IUSBDevice::serialNumber

Serial number string.

readonly attribute wstring IUSBDevice::address

Host specific address of the device.

readonly attribute unsigned short IUSBDevice::port

Host USB port number the device is physically connected to.

readonly attribute unsigned short IUSBDevice::version

The major USB version of the device - 1 or 2.

readonly attribute unsigned short IUSBDevice::portVersion

The major USB version of the host USB port the device is physically connected to - 1 or 2.

For devices not connected to anything this will have the same value as the version attribute.

readonly attribute boolean IUSBDevice::remote

Whether the device is physically connected to a remote VRDE client or to a local host machine.